"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.https = void 0;
const https_1 = require("https");
/**
 * Inbuilt https function to replace your good ol' node-fetch and axios.
 * @param host
 * @param endpoint
 * @param options
 * @link `Documentation:` ***https://simplyd.js.org/docs/Others/https***
 * @example simplydjs.https("postman-echo.com", "/get") // An Echo endpoint
 */
function https(host, endpoint, options = {
    method: 'GET',
    headers: { 'Content-Type': 'application/json' }
}) {
    return new Promise((resolve, reject) => {
        (0, https_1.request)({
            hostname: host,
            path: endpoint,
            method: options.method,
            headers: options.headers
        }, (response) => __awaiter(this, void 0, void 0, function* () {
            // Handle any redirects
            if (response.headers.location && response.statusCode != 200)
                return resolve(yield https(host, response.headers.location.replace(host, '')));
            let data = '';
            response.on('error', reject);
            response.on('data', (chunk) => (data += chunk));
            response.on('end', () => __awaiter(this, void 0, void 0, function* () {
                try {
                    resolve(JSON.parse(data));
                }
                catch (e) {
                    reject(`HttpsError | An Error Occured\n\n${e}`);
                }
            }));
        }))
            .on('error', reject)
            .end();
    });
}
exports.https = https;
