/// <reference types="node" />
import { OutgoingHttpHeaders } from 'http2';
export declare type httpsOptions = {
    method: 'GET' | 'POST' | 'PUT' | 'PATCH' | 'DELETE' | 'HEAD' | 'CONNECT' | 'OPTIONS' | 'TRACE';
    headers: OutgoingHttpHeaders;
};
/**
 * Inbuilt https function to replace your good ol' node-fetch and axios.
 * @param host
 * @param endpoint
 * @param options
 * @link `Documentation:` ***https://simplyd.js.org/docs/Others/https***
 * @example simplydjs.https("postman-echo.com", "/get") // An Echo endpoint
 */
export declare function https(host: string, endpoint: string, options?: httpsOptions): Promise<any>;
