import { TextChannel, Role } from 'discord.js';
import { ExtendedInteraction, ExtendedButtonStyle } from './interfaces';
interface Button {
    label?: string;
    role?: Role;
    style?: ExtendedButtonStyle;
    emoji?: string;
}
interface MessageContents {
    invalidMessage?: string;
    otherUserMessage?: string;
    update?: string;
    success?: string;
    overload?: string;
    noButton?: string;
}
export declare type betterbtnOptions = {
    strict?: boolean;
    type?: 'Add' | 'Remove';
    channel?: TextChannel;
    button?: Button;
    messageId?: string;
    contents?: MessageContents;
};
/**
 * A **Button Role builder** that lets **admins create** button roles. | *Requires: [**manageBtn()**](https://simplyd.js.org/docs/handler/manageBtn)*
 * @param interaction
 * @param options
 * @link `Documentation:` ***https://simplyd.js.org/docs/Systems/betterBtnRole***
 * @example simplydjs.betterBtnRole(client, interaction)
 */
export declare function betterBtnRole(interaction: ExtendedInteraction, options?: betterbtnOptions): Promise<string>;
export {};
