import { Role, Message } from 'discord.js';
import { ExtendedInteraction, ExtendedMessage, ExtendedButtonStyle, CustomizableEmbed } from './interfaces';
interface dataObject {
    role?: string | Role;
    label?: string;
    emoji?: string;
    style?: ExtendedButtonStyle;
    url?: `https://${string}`;
}
export declare type btnOptions = {
    embed?: CustomizableEmbed;
    content?: string;
    data?: dataObject[];
    strict?: boolean;
};
/**
 * A **Button Role System** that lets you create button roles with your own message. | *Requires: [**manageBtn()**](https://simplyd.js.org/docs/handler/manageBtn)*
 * @param msgOrInt
 * @param options
 * @link `Documentation:` ***https://simplyd.js.org/docs/General/btnrole***
 * @example simplydjs.btnRole(message, { data: {...} })
 */
export declare function btnRole(msgOrInt: ExtendedMessage | ExtendedInteraction, options?: btnOptions): Promise<Message>;
export {};
