import { Client, EmbedBuilder, Message } from 'discord.js';
interface TypeEmbed {
    thank?: EmbedBuilder;
    remind?: EmbedBuilder;
}
export declare type bumpOptions = {
    strict: boolean;
    content?: string;
    embed?: TypeEmbed;
    toggle?: boolean;
    channelId?: string[];
};
/**
 * A Very cool bump reminder system that reminds when a bump is necessary [Only Disboard].
 *
 * **Requires you to have this in `messageCreate` and `ready` event**
 * @param client
 * @param message
 * @param options
 * @link `Documentation:` ***https://simplyd.js.org/docs/Systems/bumpReminder***
 * @example simplydjs.bumpReminder(client, message)
 */
export declare function bumpReminder(client: Client, message: Message | bumpOptions, options: bumpOptions): Promise<boolean>;
export {};
