import { EmbedBuilder, ButtonBuilder, ActionRowBuilder } from 'discord.js';
import { ExtendedInteraction, ExtendedMessage, buttonTemplate } from './interfaces';
/**
 * **URL** of the Type: *https://simplyd.js.org/docs/General/embedPages#pagebuttons*
 */
interface Pagebuttons {
    firstBtn?: buttonTemplate;
    nextBtn?: buttonTemplate;
    backBtn?: buttonTemplate;
    lastBtn?: buttonTemplate;
    deleteBtn?: buttonTemplate;
}
export declare type pagesOption = {
    buttons?: Pagebuttons;
    skips?: boolean;
    delete?: boolean;
    dynamic?: boolean;
    count?: boolean;
    rows?: ActionRowBuilder<ButtonBuilder>[];
    embeds?: EmbedBuilder[];
    timeout?: number;
    disable?: 'Label' | 'Emoji' | 'None';
    strict?: boolean;
};
/**
 * An *powerful yet customizable* **Embed Paginator**
 *
 * @param msgOrInt
 * @param options
 * @link `Documentation:` ***https://simplyd.js.org/docs/General/buttonPages***
 * @example simplydjs.buttonPages(interaction, [embed1, embed2] )
 */
export declare function buttonPages(msgOrInt: ExtendedMessage | ExtendedInteraction, options?: pagesOption): Promise<void>;
export {};
