import { ButtonStyle, EmbedAuthorOptions, EmbedFooterOptions, ColorResolvable } from 'discord.js';
import { ExtendedInteraction, ExtendedMessage } from './interfaces';
import { LegacyStyles } from './interfaces';
/**
 * **URL** of the Type: *https://simplyd.js.org/docs/types/CustomizableEmbed*
 */
interface CustomizableEmbed {
    author?: EmbedAuthorOptions;
    title?: string;
    footer?: EmbedFooterOptions;
    color?: ColorResolvable;
    description?: string;
    credit?: boolean;
}
/**
 * **URL** of the Type: *https://simplyd.js.org/docs/General/calculator#calcbuttons*
 */
interface calcButtons {
    numbers?: ButtonStyle | LegacyStyles;
    symbols?: ButtonStyle | LegacyStyles;
    delete?: ButtonStyle | LegacyStyles;
}
export declare type calcOptions = {
    embed?: CustomizableEmbed;
    buttons?: calcButtons;
};
/**
 * An Unique **calculator** which can be *used inside Discord*
 * @param interaction
 * @param options
 * @link `Documentation:` ***https://simplyd.js.org/docs/General/calculator***
 * @example simplydjs.calculator(interaction)
 */
export declare function calculator(interaction: ExtendedMessage | ExtendedInteraction, options?: calcOptions): Promise<void>;
export {};
