import { Message } from 'discord.js';
import { ExtendedMessage } from './interfaces';
export declare type chatbotOptions = {
    strict?: boolean;
    channelId?: string | string[];
    toggle?: boolean;
    name?: string;
    developer?: string;
    gptToken?: string;
};
/**
 * A chatbot system that is both technically advanced and intelligent, and is your buddy.
 *
 * **URL** of the api: *https://simplyapi.js.org*
 * @param message
 * @param options
 * @link `Documentation:` ***https://simplyd.js.org/docs/Fun/chatbot***
 * @example simplydjs.chatbot(client, message)
 */
export declare function chatbot(message: ExtendedMessage, options?: chatbotOptions): Promise<Message>;
