import { GuildTextBasedChannel, Guild, Message, Role, TextChannel } from 'discord.js';
import { ExtendedInteraction, ExtendedMessage, CustomizableEmbed, buttonTemplate } from './interfaces';
import { EndResolve } from './handler/manageGiveaway';
interface Requirement {
    type: 'Role' | 'Guild' | 'None';
    id: string;
}
/**
 * **URL** of the Type: *https://simplyd.js.org/docs/types/Buttons/giveawaybuttons*
 */
interface giveawayButtons {
    enter?: buttonTemplate;
    end?: buttonTemplate;
    reroll?: buttonTemplate;
}
export interface GiveawayEmbeds {
    giveaway?: CustomizableEmbed;
    load?: CustomizableEmbed;
    result?: CustomizableEmbed;
}
export declare type giveawayOptions = {
    prize?: string;
    winners?: number;
    channel?: GuildTextBasedChannel | TextChannel;
    time?: string;
    buttons?: giveawayButtons;
    manager?: Role | string;
    requirements?: Requirement;
    pingRole?: Role | string;
    embed?: GiveawayEmbeds;
    type?: 'Label' | 'Emoji' | 'Both';
    strict?: boolean;
};
export interface GiveawayResolve {
    message: Message;
    winners: number;
    prize: string;
    endsAt: number;
    requirements: {
        type: 'None' | 'Role' | 'Guild';
        value: Guild | Role;
    };
}
/**
 * A **Powerful** yet simple giveaway system | *Required: **manageGiveaway()***
 * @param msgOrInt
 * @param options
 * @link `Documentation:` ***https://simplyd.js.org/docs/Systems/giveway***
 * @example simplydjs.giveaway(interaction)
 */
export declare function giveaway(msgOrInt: ExtendedMessage | ExtendedInteraction, options?: giveawayOptions): Promise<GiveawayResolve | EndResolve>;
export {};
