import { AttachmentBuilder, ButtonInteraction, Role, User } from 'discord.js';
import { buttonTemplate, CustomizableEmbed } from '../interfaces';
/**
 * **URL** of the Type: *https://simplyd.js.org/docs/Handler/manageTicket#ticketbuttons*
 */
interface ticketButtons {
    close: buttonTemplate;
    reopen: buttonTemplate;
    delete: buttonTemplate;
    transcript: buttonTemplate;
}
export declare type manageTicketOptions = {
    ticketname?: string;
    buttons?: ticketButtons;
    pingRoles?: Role[] | string[];
    category?: string;
    embed?: CustomizableEmbed;
    logChannelId?: string;
    strict?: boolean;
};
export declare type DeleteResolve = {
    type?: 'Delete';
    channelId?: string;
    user?: User;
    data?: AttachmentBuilder;
};
/**
 * A Ticket Handler for **simplydjs ticket system.**
 * @param interaction
 * @param options
 * @link `Documentation:` ***https://simplyd.js.org/docs/Handler/manageTicket***
 * @example simplydjs.manageTicket(interaction)
 */
export declare function manageTicket(interaction: ButtonInteraction, options?: manageTicketOptions): Promise<DeleteResolve>;
export {};
