import { EmbedBuilder, ActionRowBuilder, StringSelectMenuBuilder } from 'discord.js';
import { ExtendedInteraction, ExtendedMessage } from './interfaces';
/**
 * **URL** of the Type: *https://simplyd.js.org/docs/General/menuPages#deleteoption*
 */
interface deleteOption {
    enable?: boolean;
    label?: string;
    description?: string;
    emoji?: string;
}
/**
 * **URL** of the Type: *https://simplyd.js.org/docs/General/menuPages#dataobject*
 */
interface dataObject {
    label?: string;
    description?: string;
    embed?: EmbedBuilder;
    emoji?: string;
}
export declare type menuEmbOptions = {
    type?: 'Send' | 'Edit';
    rows?: ActionRowBuilder<StringSelectMenuBuilder>[];
    embed?: EmbedBuilder;
    delete?: deleteOption;
    data?: dataObject[];
    placeHolder?: string;
    strict?: boolean;
};
/**
 * An Embed paginator using Select Menus
 * @param msgOrInt
 * @param options
 * @link `Documentation:` ***https://simplyd.js.org/docs/General/menuPages***
 * @example simplydjs.menuPages(interaction, { data: {...} })
 */
export declare function menuPages(msgOrInt: ExtendedMessage | ExtendedInteraction, options?: menuEmbOptions): Promise<void>;
export {};
