import { User } from 'discord.js';
import { ExtendedInteraction, ExtendedMessage, buttonTemplate, CustomizableEmbed } from './interfaces';
/**
 * **URL** of the Type: *https://simplyd.js.org/docs/Fun/rps#rpsbuttons*
 */
interface rpsButtons {
    rock?: buttonTemplate;
    paper?: buttonTemplate;
    scissor?: buttonTemplate;
}
interface Embeds {
    request?: CustomizableEmbed;
    win?: CustomizableEmbed;
    draw?: CustomizableEmbed;
    game?: CustomizableEmbed;
    timeout?: CustomizableEmbed;
    decline?: CustomizableEmbed;
}
export declare type rpsOptions = {
    embed?: Embeds;
    buttons?: rpsButtons;
    opponent?: User;
    strict?: boolean;
};
/**
 * A classic RPS game, except this time it's on Discord to play with your pals, how cool is that ?
 *
 * @param msgOrint
 * @param options
 * @link `Documentation:` ***https://simplyd.js.org/docs/Fun/rps***
 * @example simplydjs.rps(interaction)
 */
export declare function rps(msgOrint: ExtendedMessage | ExtendedInteraction, options?: rpsOptions): Promise<unknown>;
export {};
