import { MessageReaction } from 'discord.js';
import { ExtendedMessage, CustomizableEmbed } from './interfaces';
export declare type starboardOption = {
    embed?: CustomizableEmbed;
    channelId?: string;
    min?: number;
    emoji?: string;
    strict?: boolean;
};
/**
 * Efficient yet Simplest starboard system ever existed !
 *
 * `NOTE:` **Only Use it in `messageReactionAdd`, `messageReactionRemove` and `messageDelete` events.**
 * @param reaction
 * @param options
 * @link `Documentation:` ***https://simplyd.js.org/docs/Systems/starboard***
 * @example simplydjs.starboard(reaction, { channelId: '1234567890123' })
 */
export declare function starboard(reactionOrMessage: MessageReaction | ExtendedMessage, options?: starboardOption): Promise<import("discord.js").Message<true>>;
