import { TextChannel, Message, InteractionResponse } from 'discord.js';
import { ExtendedInteraction, ExtendedMessage, CustomizableEmbed, buttonTemplate } from './interfaces';
/**
 * **URL** of the Type: *https://simplyd.js.org/docs/Systems/suggest#suggestbuttons*
 */
interface suggestButtons {
    votedInfo?: buttonTemplate;
    upvote?: buttonTemplate;
    downvote?: buttonTemplate;
}
export interface Progress {
    up: string;
    down: string;
    blank: string;
}
export declare type suggestOption = {
    embed?: CustomizableEmbed;
    channelId?: string | TextChannel;
    suggestion?: string;
    buttons?: suggestButtons;
    progress?: Progress;
    strict: boolean;
};
/**
 * An **Beautiful** suggestion system with buttons ;D | *Requires: [**manageSug()**](https://simplyd.js.org/docs/handler/manageSug)*
 * @param msgOrint
 * @param options
 * @link `Documentation:` ***https://simplyd.js.org/docs/Systems/suggestSystem***
 * @example simplydjs.suggestSystem(interaction, { channelId: '1234567890123' })
 */
export declare function suggest(msgOrint: ExtendedMessage | ExtendedInteraction, options?: suggestOption): Promise<Message<boolean> | InteractionResponse<boolean>>;
export {};
