import { User } from 'discord.js';
import { CustomizableEmbed, ExtendedButtonStyle, ExtendedInteraction, ExtendedMessage } from './interfaces';
/**
 * **URL** of the Type: *https://simplyd.js.org/docs/Fun/tictactoe#tictactoebtntemplate*
 */
interface tictactoeBtnTemplate {
    style?: ExtendedButtonStyle;
    emoji?: string;
}
/**
 * **URL** of the Type: *https://simplyd.js.org/docs/Fun/tictactoe#tictactoebuttons*
 */
interface tictactoeButtons {
    X?: tictactoeBtnTemplate;
    O?: tictactoeBtnTemplate;
    blank?: tictactoeBtnTemplate;
}
interface Embeds {
    request?: CustomizableEmbed;
    win?: CustomizableEmbed;
    draw?: CustomizableEmbed;
    game?: CustomizableEmbed;
    timeout?: CustomizableEmbed;
    decline?: CustomizableEmbed;
}
export declare type tictactoeOptions = {
    embed?: Embeds;
    user?: User;
    type?: 'Button' | 'Embed';
    buttons?: tictactoeButtons;
    strict?: boolean;
};
/**
 * One line implementation of a super enjoyable **tictactoe game**.
 * @param message
 * @param options
 * @link `Documentation:` ***https://simplyd.js.org/docs/Fun/tictactoe***
 * @example simplydjs.tictactoe(interaction)
 */
export declare function tictactoe(message: ExtendedMessage | ExtendedInteraction, options?: tictactoeOptions): Promise<User>;
export {};
